#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using bl = bool;

queue<ll>Q;
vector<ll>dist;
vector<bl>visited;
vector<vector<ll>>G;
set<pair<ll,ll>>polz;
vector<bl>prop;
vector<ll>sold;
vector<bl>used;
vector<vector<ll>>comp;
ll cmp=0;

void dfs(ll n){
    used[n]=true;
    comp[cmp].push_back(n);
    for (auto u:G[n]){
        if (!used[u]){
            dfs(u);
        }
    }
}

void bfs(){
    while (!Q.empty() || !polz.empty()) {
        if (Q.empty()) {
            while (!polz.empty()) {
                auto z = *polz.begin();
                // cout<<z.second<<" "<<"from P"<<endl;
                polz.erase(polz.begin());
                dist[z.second] = z.first;
                visited[z.second] = true;
                for (auto u: G[z.second]) {
                    if (!visited[u]) {
                        if (prop[u] && dist[z.second] + 1 < sold[u]) {
                            dist[u] = dist[z.second] + 1;
                            prop[u] = false;
                            Q.push(u);
                            polz.erase({sold[u], u});
                            visited[u] = true;
                        } else if (prop[u]) {
                            continue;
                        } else {
                            visited[u] = true;
                            dist[u] = dist[z.second] + 1;
                        }
                    }
                }
            }
        } else {
            if (!polz.empty()) {
                while (polz.begin()->first <= dist[Q.front()]) {
                    auto z = *polz.begin();
                    // cout<<z.second<<" "<<"from P"<<endl;
                    polz.erase(polz.begin());
                    dist[z.second] = z.first;
                    visited[z.second] = true;
                    for (auto u: G[z.second]) {
                        if (!visited[u]) {
                            if (prop[u] && dist[z.second] + 1 < sold[u]) {
                                dist[u] = dist[z.second] + 1;
                                prop[u] = false;
                                Q.push(u);
                                polz.erase({sold[u], u});
                                visited[u] = true;
                            } else if (prop[u]) {
                                continue;
                            } else {
                                visited[u] = true;
                                dist[u] = dist[z.second] + 1;
                            }
                        }
                    }
                }
            }
            ll z = Q.front();
            // cout<<z<<" "<<"from Q"<<endl;
            Q.pop();
            for (auto u: G[z]) {
                if (!visited[u]) {
                    if (prop[u] && dist[z] + 1 <= sold[u]) {
                        dist[u] = dist[z] + 1;
                        prop[u] = false;
                        Q.push(u);
                        polz.erase({sold[u], u});
                        visited[u] = true;
                    } else if (prop[u]) {
                        continue;
                    } else {
                        visited[u] = true;
                        dist[u] = dist[z] + 1;
                        Q.push(u);
                    }
                }
            }
        }
    }
}

int main() {
    ll i,j,n,m,k;
    cin>>n>>m>>k;
    dist.resize(n,1e9);
    visited.resize(n);
    G.resize(n);
    used.resize(n);
    sold.resize(n);
    prop.resize(n);
    comp.resize(n);
    for (i=0;i<m;i++){
        ll a,b;
        cin>>a>>b;
        a--;
        b--;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    for (i=0;i<n;i++){
        if (!used[i]){
            dfs(i);
            cmp++;
        }
    }
    vector<ll>bridge(n);
    vector<ll>ans;
    for (i=0;i<k;i++){
        ll a,b;
        cin>>a>>b;
        a--;
        bridge[a]=b;
    }
    for (i=0;i<cmp;i++){
        ll mxb=0;
        for (j=0;j<comp[i].size();j++){
            mxb=max(mxb,bridge[comp[i][j]]);
        }
        for (j=0;j<comp[i].size();j++){
            if (bridge[comp[i][j]]!=0){
                prop[comp[i][j]]=true;
                if (bridge[comp[i][j]]==mxb){
                    dist[comp[i][j]]=0;
                    visited[comp[i][j]]=true;
                    Q.push(comp[i][j]);
                }
                else{
                    sold[comp[i][j]]=mxb-bridge[comp[i][j]];
                    polz.insert({sold[comp[i][j]],comp[i][j]});
                }
            }
        }
        bfs();
        for (j=0;j<comp[i].size();j++){
            if (dist[comp[i][j]]<=mxb){
                ans.push_back(comp[i][j]);
            }
        }
        polz.clear();
    }
    cout<<ans.size()<<endl;
    sort(ans.begin(),ans.end());
    for (i=0;i<ans.size();i++){
        cout<<ans[i]+1<<" ";
    }
    cout<<endl;
    return 0;
}
